%%==============================================================================
%% PropEr Custom Generators
%%==============================================================================
-module(els_proper_gen).

%%==============================================================================
%% Includes
%%==============================================================================
-include_lib("proper/include/proper.hrl").

%%==============================================================================
%% Exports
%%==============================================================================
-compile(export_all).

%%==============================================================================
%% Generators
%%==============================================================================
uri() ->
  ?LET( B
      , document()
      , <<"file:///tmp/", B/binary, ".erl">>
      ).

root_uri() ->
  <<"file:///tmp">>.

init_options() ->
  #{<<"indexingEnabled">> => false}.

document() ->
  elements([<<"a">>, <<"b">>, <<"c">>]).

tokens() ->
  ?LET( Tokens
      , vector(10, token())
      , begin
          Concatenated = [string:join(Tokens, ","), "."],
          els_utils:to_binary(Concatenated)
        end
      ).

token() ->
  elements(["foo", "Bar", "\"baz\""]).
